/*
 *  Copyright (C) 2013  Thadeu Lima de Souza Cascardo <cascardo@cascardo.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef _SGP_GROUP_H
#define _SGP_GROUP_H

#include <stdlib.h> /* for NULL */
#include <sgp/friend.h>

struct sgp_group;

struct sgp_group * sgp_group_new(char *);
void sgp_group_destroy(struct sgp_group *);
char * sgp_group_get_name(struct sgp_group *);
int sgp_group_add_friend(struct sgp_group *, struct sgp_friend *);

#define sgp_foreach_friend(group, friend, pfriend) \
	for (pfriend = sgp_group_first(group), friend = pfriend ? *pfriend : NULL; \
		pfriend != NULL; \
		pfriend = sgp_group_next(group, pfriend), friend = pfriend ? *pfriend : NULL)

struct sgp_friend ** sgp_group_first(struct sgp_group *);
struct sgp_friend ** sgp_group_next(struct sgp_group *, struct sgp_friend **);

#endif
